/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : LED4.c
**     Project     : ProcessorExpert
**     Processor   : MK40DX256ZVMD10
**     Component   : LED
**     Version     : Component 01.047, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-11-14, 09:32, # CodeGen: 12
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         On     - void LED4_On(void);
**         Off    - void LED4_Off(void);
**         Neg    - void LED4_Neg(void);
**         Get    - byte LED4_Get(void);
**         Put    - void LED4_Put(byte val);
**         Init   - void LED4_Init(void);
**         Deinit - void LED4_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing an LED driver using Processor Expert.
**     This is a free software and is opened for education,  research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE LED4. */

#include "LED4.h"

/*
** ===================================================================
**     Method      :  LED4_On (component LED)
**
**     Description :
**         This turns the LED on.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED4_On(void)
{
  GPIO2_ClearPortBits(NULL, GPIO2_LED_E4_MASK);
}

/*
** ===================================================================
**     Method      :  LED4_Off (component LED)
**
**     Description :
**         This turns the LED off.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED4_Off(void)
{
  GPIO2_SetPortBits(NULL, GPIO2_LED_E4_MASK);
}

/*
** ===================================================================
**     Method      :  LED4_Neg (component LED)
**
**     Description :
**         This negates/toggles the LED
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED4_Neg(void)
{
  GPIO2_TogglePortBits(NULL, GPIO2_LED_E4_MASK);
}

/*
** ===================================================================
**     Method      :  LED4_Get (component LED)
**
**     Description :
**         This returns logical 1 in case the LED is on, 0 otherwise.
**     Parameters  : None
**     Returns     :
**         ---             - Status of the LED (on or off)
** ===================================================================
*/
byte LED4_Get(void)
{
  return (byte)!((GPIO2_GetPortValue(NULL)&GPIO2_LED_E4_MASK)!=0);
}

/*
** ===================================================================
**     Method      :  LED4_Init (component LED)
**
**     Description :
**         Performs the LED driver initialization.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED4_Init(void)
{
  (void)GPIO2_Init(NULL);
  LED4_Off();
}

/*
** ===================================================================
**     Method      :  LED4_Put (component LED)
**
**     Description :
**         Turns the LED on or off.
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - value to define if the LED has to be on or
**                           off.
**     Returns     : Nothing
** ===================================================================
*/
void LED4_Put(byte val)
{
  if(val) {
    LED4_On();
  } else {
    LED4_Off();
  }
}

/*
** ===================================================================
**     Method      :  LED4_Deinit (component LED)
**
**     Description :
**         Deinitializes the driver
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LED4_Deinit(void)
{
  GPIO2_Deinit(NULL);
}

/* END LED4. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
