/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : Tx1.c
**     Project     : ProcessorExpert
**     Processor   : MK40DX256ZVMD10
**     Component   : RingBufferUInt8
**     Version     : Component 01.003, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-11-14, 09:32, # CodeGen: 12
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Put             - byte Tx1_Put(byte elem);
**         Get             - byte Tx1_Get(byte *elemP);
**         NofElements     - byte Tx1_NofElements(void);
**         NofFreeElements - byte Tx1_NofFreeElements(void);
**         Init            - void Tx1_Init(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software of an embedded component for Processor Expert.
**     This is a free software and is opened for education,  research  and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE Tx1. */

#include "Tx1.h"

static uint8_t Tx1_buffer[Tx1_BUF_SIZE]; /* ring buffer */
static uint8_t Tx1_inIdx;  /* input index */
static uint8_t Tx1_outIdx; /* output index */
static uint8_t Tx1_inSize; /* size of input data */
/*
** ===================================================================
**     Method      :  Tx1_Put (component RingBufferUInt8)
**
**     Description :
**         Puts a new element into the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**         elem            - New element to be put into the buffer
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte Tx1_Put(byte elem)
{
  byte res = ERR_OK;

  EnterCritical();
  if (Tx1_inSize==Tx1_BUF_SIZE) {
    res = ERR_TXFULL;
  } else {
    Tx1_buffer[Tx1_inIdx] = elem;
    Tx1_inSize++;
    Tx1_inIdx++;
    if (Tx1_inIdx==Tx1_BUF_SIZE) {
      Tx1_inIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  Tx1_Get (component RingBufferUInt8)
**
**     Description :
**         Removes an element from the buffer
**     Parameters  :
**         NAME            - DESCRIPTION
**       * elemP           - Pointer to where to store the received
**                           element
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte Tx1_Get(byte *elemP)
{
  byte res = ERR_OK;

  EnterCritical();
  if (Tx1_inSize==0) {
    res = ERR_RXEMPTY;
  } else {
    *elemP = Tx1_buffer[Tx1_outIdx];
    Tx1_inSize--;
    Tx1_outIdx++;
    if (Tx1_outIdx==Tx1_BUF_SIZE) {
      Tx1_outIdx = 0;
    }
  }
  ExitCritical();
  return res;
}

/*
** ===================================================================
**     Method      :  Tx1_NofElements (component RingBufferUInt8)
**
**     Description :
**         Returns the actual number of elements in the buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte Tx1_NofElements(void)
{
  return Tx1_inSize;
}

/*
** ===================================================================
**     Method      :  Tx1_NofFreeElements (component RingBufferUInt8)
**
**     Description :
**         Returns the actual number of free elements/space in the
**         buffer.
**     Parameters  : None
**     Returns     :
**         ---             - Number of elements in the buffer.
** ===================================================================
*/
byte Tx1_NofFreeElements(void)
{
  return (byte)(Tx1_BUF_SIZE-Tx1_inSize);
}

/*
** ===================================================================
**     Method      :  Tx1_Init (component RingBufferUInt8)
**
**     Description :
**         Initializes the data structure
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void Tx1_Init(void)
{
  Tx1_inIdx = 0;
  Tx1_outIdx = 0;
  Tx1_inSize = 0;
}

/* END Tx1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
