/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : USB1.c
**     Project     : ProcessorExpert
**     Processor   : MK40DX256ZVMD10
**     Component   : FSL_USB_Stack
**     Version     : Component 01.009, Driver 01.00, CPU db: 3.00.003
**     Compiler    : CodeWarrior ARM C Compiler
**     Date/Time   : 2012-11-14, 09:32, # CodeGen: 12
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         Init - byte USB1_Init(void);
**
**     (c) Copyright Freescale, all rights reserved, 2012
**     Ported as Processor Expert component: Erich Styger
**     http: www.freescale.com
** ###################################################################*/

/* MODULE USB1. */

#include "USB1.h"
#include "derivative.h"     /* include peripheral declarations */
#include "types.h"          /* Contains User Defined Data Types */

/*
** ===================================================================
**     Method      :  USB1_usb_int_dis (component FSL_USB_Stack)
**
**     Description :
**         Disables USB interrupts (if supported)
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void USB1_usb_int_dis(void)
{
  /* functionality not needed for Kinetis K40 */
}

/*
** ===================================================================
**     Method      :  USB1_usb_int_en (component FSL_USB_Stack)
**
**     Description :
**         Enables USB interrupts (if supported).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void USB1_usb_int_en(void)
{
  /* Kinetis K40 */
#if !HIGH_SPEED_DEVICE
  NVICICER2 |= (1<<9);   /* Clear any pending interrupts on USB */
  NVICISER2 |= (1<<9);   /* Enable interrupts from USB module */
#else
  NVICICER3 |= 1;        /* Clear any pending interrupts on USBHS */
  NVICISER3 |= 1;        /* Enable interrupts on USBHS */
#endif
}

/*
** ===================================================================
**     Method      :  USB1_Init (component FSL_USB_Stack)
**
**     Description :
**         Initializes the driver
**     Parameters  : None
**     Returns     :
**         ---             - Error code
** ===================================================================
*/
byte USB1_Init(void)
{
  byte err;

  /* Initialize the USB interface */
  err = CDC1_Init();
  if(err != ERR_OK) {
    /* Error initializing USB Class */
    return ERR_FAILED;
  }
  /* for Kinetis only */
  #if !HIGH_SPEED_DEVICE
    NVICICER2 |= (1<<9);        /* Clear any pending interrupts on USB */
    NVICISER2 |= (1<<9);        /* Enable interrupts from USB module */
  #else // HIGH_SPEED_DEVICE
    NVICICER3 |= 1;        /* Clear any pending interrupts on USBHS */
    NVICISER3 |= 1;        /* Enable interrupts on USBHS */
  #endif
  USB1_usb_int_en();
  return ERR_OK;
}

/* END USB1. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
